(function(f){if(typeof exports==="object"&&typeof module!=="undefined"){module.exports=f()}else if(typeof define==="function"&&define.amd){define([],f)}else{var g;if(typeof window!=="undefined"){g=window}else if(typeof global!=="undefined"){g=global}else if(typeof self!=="undefined"){g=self}else{g=this}g.installerIntegrationPluginExtension = f()}})(function(){var define,module,exports;return (function(){function r(e,n,t){function o(i,f){if(!n[i]){if(!e[i]){var c="function"==typeof require&&require;if(!f&&c)return c(i,!0);if(u)return u(i,!0);var a=new Error("Cannot find module '"+i+"'");throw a.code="MODULE_NOT_FOUND",a}var p=n[i]={exports:{}};e[i][0].call(p.exports,function(r){var n=e[i][1][r];return o(n||r)},p,p.exports,r,e,n,t)}return n[i].exports}for(var u="function"==typeof require&&require,i=0;i<t.length;i++)o(t[i]);return o}return r})()({1:[function(require,module,exports){

},{}],2:[function(require,module,exports){
const _ = require("lodash");
const $ = require("jquery");
const ko = require("knockout");
const toastr = require("toastr");

const settingsForm = require("./settings.pug");
const SettingsForm = require("./plugins/settingsForm");

const wait = require("./wait");
const {observableMoment} = require("./time");

const packageNames = require("./packageNames");

function InstalledUpdate (data)
{
    if (!(this instanceof InstalledUpdate))
    {
        return new InstalledUpdate(data);
    }
    
    _(this).extend(data).value();
    this.time = observableMoment(this.timestamp);
}

function InstallerIntegrationExtension (plugin)
{
    var updates = ko.observable({
        timestamp: -1,
        updates: {}
    });

    const areUpdatesAvailable = ko.computed(() => {
        return !!_(updates().updates).values().reduce((sum, updatesList) => {
            return sum + updatesList.length;
        }, 0);
    });

    var license = ko.observable({
        licensedTo: "Unknown",
        key: ko.observable(),
        serial: "unknown",
        valid: false,
        created: null,
        activated: null,
        expirationDate: null,
        updateChannel: "????"
    });

    var progress = ko.observable({
       progress: 0,
       message: ""
    });

    var updateLog = ko.observableArray();

    var hasStartedUpdateCheck = false;
    var isWaitingForRestart = false;

    function updateLicense (licenseInfo)
    {
        license(_(licenseInfo).extend({
            key: ko.observable(licenseInfo.key),
            created: licenseInfo.created > -1 ? observableMoment(licenseInfo.created) : null,
            activated: licenseInfo.activated > -1 ? observableMoment(licenseInfo.activated) : null,
            expirationDate: licenseInfo.expirationDate > -1 ? observableMoment(licenseInfo.expirationDate) : null
        }).value());
    }

    function refresh ()
    {
        plugin.services.getFoundUpdates().then(result => {
            if (result)
            {
                updates(result);
            }
        });
        
        plugin.services.getLicenseInfo().then(updateLicense);
        plugin.services.getInstalledUpdateLog().then(updates => {
            updateLog(_(updates).sortBy(update => -update.timestamp).map(InstalledUpdate).value());
        });
        plugin.services.getInstallProgress().then(progress);
    }

    /*function updatesAvailableModal (updates, callback)
    {
        var $modal = $(updatesModalTemplate({
            updates: updates,
            areUpdatesAvailable: areUpdatesAvailable(),
            packageNames: packageNames,
            _d: _
        }));
        
        $modal.find(".btn-primary").click(callback);
        
        return $modal.modal("show");
    }*/

    function checkOrShowUpdates ()
    {
        areUpdatesAvailable() ? showAvailableUpdates() : startUpdateCheck();        
    }

    function startUpdateCheck ()
    {
        wait.open("Checking for updates, please wait...");
        hasStartedUpdateCheck = true;
        plugin.services.triggerUpdateCheck();
    }

    const updatesAvailableModal = require("./updates");
    function showAvailableUpdates ()
    {
        return updatesAvailableModal.open(updates().updates, areUpdatesAvailable())
            .then(installUpdates);
    }

    function installUpdates ()
    {
        plugin.services.installUpdates().then(() => {
            progress({
                progress: 0,
                message: "Beginning update"
            });
        });    
    }
    
    function registerCaptureCast ()
    {
        wait.open("Registering CaptureCast, please wait...");
        plugin.services.register({
            licenseKey: license().key()
        }).then(licenseInfo => {
            updateLicense(licenseInfo);
            wait.hide();
        }).catch(() => {
            wait.hide();
            toastr.error("Failed to register CaptureCast");
        });
    }

    function forgetUpdateCheckResult ()
    {
        plugin.services.forgetUpdateCheckResult().then(() => {
            updates({
                updates: {}
            });
        });
    }

    // Installation progress modal
    const progressModal = require("./update-progress");
    
    // Update progress modal when an event is received
    const {uiEventSource, capturecastEventSource} = require("./environment");
    capturecastEventSource.addEventListener("UpdateInstalledEvent", event => {
        progress(event);
        console.log(event);
    });

    // If user initiated an update check, show them the installed updates
    // afterwards. If this is an event that came from an update check
    // running in the background then update the observable (and maybe show
    // a toast?) but do not show the modal.
    capturecastEventSource.addEventListener("UpdatesAvailableEvent", event => {
        var result = event.updates;
        updates(result);
        
        if (!hasStartedUpdateCheck)
        {
            return;
        }    
        
        hasStartedUpdateCheck = false;
        wait.hide();
        showAvailableUpdates();
    });

    // If update check failed for whatever reason, cancel the update check modal
    // and show an error.
    capturecastEventSource.addEventListener("UpdateCheckFailedEvent", event => {
        if (!hasStartedUpdateCheck)
        {
            return;
        }
        
        hasStartedUpdateCheck = false;
        wait.hide();
        toastr.error("CaptureCast update check failed: " + event.message);    
    });
    
    // If UI has re-inited after updates have installed, this probably means
    // we have finished restarting, so dismiss the wait modal.
    uiEventSource.addEventListener("init", event => {
        if (!isWaitingForRestart)
        {
            return;
        }
        
        isWaitingForRestart = false;
        wait.hide();
        updatesAvailableModal.hide();
    });

    /*addEventListener("WINDOW_VISIBLE", function () {
        if (!hasStartedUpdateCheck)
        {
            return;
        }
        
        plugin.services.isRunningUpdateCheck().then(function (isRunningUpdateCheck) {
            if (isRunningUpdateCheck)
            {
                return;
            }
            
            hasStartedUpdateCheck = false;
            wait.dismiss();
            plugin.services.getFoundUpdates().then(function (result) {
                if (result)
                {
                    updates(result);
                    showAvailableUpdates();
                }
            });        
        });
    });*/
    
    plugin.updates = updates;
    plugin.areUpdatesAvailable = areUpdatesAvailable;
    plugin.license = license;
    plugin.progress = progress;
    plugin.updateLog = updateLog;
    plugin.installUpdates = installUpdates;
    plugin.forgetUpdateCheckResult = forgetUpdateCheckResult;
    plugin.checkOrShowUpdates = checkOrShowUpdates;

    // Check updates button
    const buttonId = "check-update-button";
    const buttonBindings = "visible: license().valid, " +
                           "text: areUpdatesAvailable() ? 'Updates Available' : 'Check for Updates'";

    var $button = $("<button>").attr("id", buttonId)
                               .attr("data-bind", buttonBindings)
                               .addClass("primary-button")
                               .text("Check for Updates")
                               .click(checkOrShowUpdates);

    // Attach button to footer, next to the unit version thing.
    ko.applyBindings(plugin, $button[0]);
    const footerVersion = $("body > footer").find(".prop.version");
    footerVersion.find(`#${buttonId}`).remove();
    footerVersion.append($button);

    // Keep progress modal visible while progress updates are being consumed
    progress.subscribe(progress => {
        if (!progress)
        {
            return;
        }
        
        if (progress.progress >= 1)
        {
            progressModal.hide();
            isWaitingForRestart = true;
            wait.open("Finished installing updates. Restarting CaptureCast, please wait...");
            return;
        }
        
        progressModal.open(progress);
    });
    
    plugin.settingsForm = SettingsForm(plugin, settingsForm, [
        ["update-check-enabled", "boolean"]
    ], function (parent) {
        this.license = license;
        this.updateLog = updateLog;
        this.areUpdatesAvailable = areUpdatesAvailable;
        this.packageNames = packageNames;
        
        this.checkOrShowUpdates = checkOrShowUpdates;
        
        this.register = function register ()
        {
            if (!license().valid && license().key())
            {
                registerCaptureCast();
            }
        };
        
        this.submit = function submit ()
        {
            this.register();
            return parent.submit();
        };
    });
    
    // Create settings panel
    /*addSettingsPanel({
        link: {
            icon: "icon-key",
            text: "Licensing and Updates",
            link: "#settings-updates",
            after: "#settings-nav-general + li + li + li + li + li + li"
        },
        panel: this.templates.settingsPanel
    });*/

    // Add our events as notifiable events.
    //CatturaBox.notifications.addNotifiableEvent("System", "UpdatesAvailableEvent", "Updates for CaptureCast are available");
    //CatturaBox.notifications.addNotifiableEvent("System", "UpdatesInstalledEvent", "CaptureCast updates have been installed");
    
    refresh();
    return plugin;
}

module.exports = InstallerIntegrationExtension;

},{"./environment":undefined,"./packageNames":3,"./plugins/settingsForm":undefined,"./settings.pug":4,"./time":undefined,"./update-progress":6,"./updates":8,"./wait":undefined,"jquery":"jquery","knockout":"knockout","lodash":"lodash","toastr":undefined}],3:[function(require,module,exports){
module.exports = {
    "cattura-capturecast-platform": "Cattura CaptureCast Platform",

    "cattura-web-ui-plugin": "Web UI",
    "cattura-web-api-plugin": "Web API",
    "cattura-web-console-plugin": "Web Console",
    "cattura-graph-builder-api-plugin": "Graph Builder API",
    "cattura-web-server-plugin": "Cattura Embedded Web Server",
    "cattura-web-upload-service-plugin": "Web Upload Service",
    "cattura-live-preview-plugin": "Live Preview",
    "cattura-schedule-form-plugin": "Custom Schedule Form",
    "cattura-log-downloader-plugin": "Log Downloader",
    
    "cattura-graph-visualizer-plugin": "Graph Visualizer",
    "cattura-mediainfo-plugin": "MediaInfo Viewer",
    
    "cattura-audio-level-plugin": "PPM Analyzer",
    "cattura-audio-level-viewer-plugin": "PPM Viewer",
    
    "cattura-v4l-capture-plugin": "Video4Linux Capture",
    "cattura-alsa-capture-plugin": "ALSA Capture",
    "cattura-java-sound-capture-plugin": "JavaSound Capture",
    
    "cattura-shotdetect-plugin": "Scene Change Detection",
    "cattura-tesseract-ocr-plugin": "Optical Character Recognition",
    
    "cattura-xuggler-resampler-plugin": "Frame Resampler",
    "cattura-frame-compositor-plugin": "Frame Compositor",
    
    "cattura-xuggle-writer-plugin": "Media Writer",
    "cattura-save-frame-plugin": "Image Writer",
    
    "cattura-rtmp-streaming-plugin": "RTMP Streamer",
    
    "cattura-vimeo-plugin": "Vimeo Publishing",
    "cattura-matterhorn-publishing-plugin": "Opencast Publishing",
    "cattura-sftp-plugin": "SFTP Publishing",
    "cattura-google-drive-plugin": "Google Drive Publishing",
    "cattura-youtube-plugin": "YouTube Publishing",
    "cattura-kaltura-plugin": "Kaltura Publishing",
    "cattura-ftp-plugin": "FTP Publishing",
    "cattura-box-plugin": "Box Publishing",
    "cattura-panopto-plugin": "Panopto Publishing",
    
    "cattura-scheduler-plugin": "Scheduler",
    "cattura-kaltura-scheduler-plugin": "Kaltura Scheduling",
    
    "cattura-media-clipper-plugin": "Media Clipper",
    "cattura-media-package-importer-plugin": "Media Importer",
    
    "cattura-ldap-plugin": "LDAP Authentication",
    
    "cattura-minimal-distribution": "Cattura Minimal Distribution",
    "cattura-sudo-rules": "Cattura Sudo Rules",
    
    "cattura-os-setup": "Cattura Operating System Setup",
    "cattura-customer-user": "Cattura CaptureCast User Account",
    "cattura-capturecast-installer": "Cattura CaptureCast Installer",
    "oracle-java8-installer": "Oracle Java 8",
    "cattura-nginx": "Nginx Frontend Web Server",
    
    "cattura-datapath-drivers": "Datapath Drivers",
    "cattura-magewell-pro-capture-drivers": "Magewell Pro Capture Drivers",
    "cattura-magewell-eco-capture-drivers": "Magewell Eco Capture Drivers",
    
    "google-chrome-stable": "Google Chrome Web Browser",
    "teamviewer": "TeamViewer"
};

},{}],4:[function(require,module,exports){
var pug = require('pug-runtime');
module.exports=template;function pug_attr(t,e,n,r){if(!1===e||null==e||!e&&("class"===t||"style"===t))return"";if(!0===e)return" "+(r?t:t+'="'+t+'"');var f=typeof e;return"object"!==f&&"function"!==f||"function"!=typeof e.toJSON||(e=e.toJSON()),"string"==typeof e||(e=JSON.stringify(e),n||-1===e.indexOf('"'))?(n&&(e=pug_escape(e))," "+t+'="'+e+'"'):" "+t+"='"+e.replace(/'/g,"&#39;")+"'"}
function pug_attrs(t,r){var a="";for(var s in t)if(pug_has_own_property.call(t,s)){var u=t[s];if("class"===s){u=pug_classes(u),a=pug_attr(s,u,!1,r)+a;continue}"style"===s&&(u=pug_style(u)),a+=pug_attr(s,u,!1,r)}return a}
function pug_classes(s,r){return Array.isArray(s)?pug_classes_array(s,r):s&&"object"==typeof s?pug_classes_object(s):s||""}
function pug_classes_array(r,a){for(var s,e="",u="",c=Array.isArray(a),g=0;g<r.length;g++)(s=pug_classes(r[g]))&&(c&&a[g]&&(s=pug_escape(s)),e=e+u+s,u=" ");return e}
function pug_classes_object(r){var a="",n="";for(var o in r)o&&r[o]&&pug_has_own_property.call(r,o)&&(a=a+n+o,n=" ");return a}
function pug_escape(e){var a=""+e,t=pug_match_html.exec(a);if(!t)return e;var r,c,n,s="";for(r=t.index,c=0;r<a.length;r++){switch(a.charCodeAt(r)){case 34:n="&quot;";break;case 38:n="&amp;";break;case 60:n="&lt;";break;case 62:n="&gt;";break;default:continue}c!==r&&(s+=a.substring(c,r)),c=r+1,s+=n}return c!==r?s+a.substring(c,r):s}
var pug_has_own_property=Object.prototype.hasOwnProperty;
var pug_match_html=/["&<>]/;
function pug_merge(e,r){if(1===arguments.length){for(var t=e[0],g=1;g<e.length;g++)t=pug_merge(t,e[g]);return t}for(var l in r)if("class"===l){var n=e[l]||[];e[l]=(Array.isArray(n)?n:[n]).concat(r[l]||[])}else if("style"===l){var n=pug_style(e[l]);n=n&&";"!==n[n.length-1]?n+";":n;var a=pug_style(r[l]);a=a&&";"!==a[a.length-1]?a+";":a,e[l]=n+a}else e[l]=r[l];return e}
function pug_rethrow(n,e,r,t){if(!(n instanceof Error))throw n;if(!("undefined"==typeof window&&e||t))throw n.message+=" on line "+r,n;try{t=t||require("fs").readFileSync(e,"utf8")}catch(e){pug_rethrow(n,null,r)}var i=3,a=t.split("\n"),o=Math.max(r-i,0),h=Math.min(a.length,r+i),i=a.slice(o,h).map(function(n,e){var t=e+o+1;return(t==r?"  > ":"    ")+t+"| "+n}).join("\n");throw n.path=e,n.message=(e||"Pug")+":"+r+"\n"+i+"\n\n"+n.message,n}
function pug_style(r){if(!r)return"";if("object"==typeof r){var t="";for(var e in r)pug_has_own_property.call(r,e)&&(t=t+e+":"+r[e]+";");return t}return r+""}function template(locals) {var pug_html = "", pug_mixins = {}, pug_interp;
var pug_indent = [];


































































pug_html = pug_html + "\n\u003Cdiv class=\"filter-bar\"\u003E";

pug_html = pug_html + "\n  \u003Ch2\u003E";

pug_html = pug_html + "Updates and Licensing\u003C\u002Fh2\u003E";

pug_html = pug_html + "\n  \u003Cdiv class=\"flex-stretcher\"\u003E\u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n  \u003Cbutton class=\"principal-button\" data-bind=\"visible: license().valid, click: checkOrShowUpdates, text: areUpdatesAvailable() ? 'Updates Available' : 'Check for Updates'\"\u003E";

pug_html = pug_html + "Check for Updates\u003C\u002Fbutton\u003E\n\u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n\u003Cdiv class=\"settings-form\"\u003E";

pug_html = pug_html + "\n  \u003Ch3\u003E";

pug_html = pug_html + "Licensing Info\u003C\u002Fh3\u003E";

pug_html = pug_html + "\n  \u003Cdiv data-bind=\"with: license\"\u003E";

pug_html = pug_html + "\n    \u003Cdiv class=\"control\" data-bind=\"visible: created\"\u003E";

pug_html = pug_html + "\n      \u003Clabel\u003E";

pug_html = pug_html + "Licensed to\u003C\u002Flabel\u003E";

pug_html = pug_html + "\n      \u003Cp data-bind=\"text: licensedTo\"\u003E";

pug_html = pug_html + "????? (\u003Cspan data-bind=\"text: email\"\u003E?????\u003C\u002Fspan\u003E)\u003C\u002Fp\u003E\n    \u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n    \u003Cdiv class=\"control\"\u003E";

pug_html = pug_html + "\n      \u003Clabel\u003E";

pug_html = pug_html + "License key\u003C\u002Flabel\u003E";

pug_html = pug_html + "\n      \u003Cinput type=\"text\" data-bind=\"textInput: key, disable: valid\"\u002F\u003E\n    \u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n    \u003Cdiv class=\"control\" data-bind=\"visible: created\"\u003E";

pug_html = pug_html + "\n      \u003Clabel\u003E";

pug_html = pug_html + "Serial\u003C\u002Flabel\u003E";

pug_html = pug_html + "\n      \u003Cp data-bind=\"text: serial\"\u003E";

pug_html = pug_html + "???\u003C\u002Fp\u003E\n    \u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n    \u003Cdiv data-bind=\"visible: created\"\u003E";

pug_html = pug_html + "\n      \u003Cdiv class=\"control\"\u003E";

pug_html = pug_html + "\n        \u003Clabel\u003E";

pug_html = pug_html + "License valid\u003C\u002Flabel\u003E";

pug_html = pug_html + "\n        \u003Cp data-bind=\"text: valid ? 'Yes' : 'No', css: { valid: valid, invalid: !valid }\"\u003E";

pug_html = pug_html + "???\u003C\u002Fp\u003E\n      \u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n      \u003Cdiv class=\"control\"\u003E";

pug_html = pug_html + "\n        \u003Clabel\u003E";

pug_html = pug_html + "Licensed since\u003C\u002Flabel\u003E";

pug_html = pug_html + "\n        \u003Cp data-bind=\"text: created\"\u003E";

pug_html = pug_html + "????-??-??\u003C\u002Fp\u003E\n      \u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n      \u003Cdiv class=\"control\"\u003E";

pug_html = pug_html + "\n        \u003Clabel\u003E";

pug_html = pug_html + "Activated on\u003C\u002Flabel\u003E";

pug_html = pug_html + "\n        \u003Cp data-bind=\"text: activated\"\u003E";

pug_html = pug_html + "????-??-??\u003C\u002Fp\u003E\n      \u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n      \u003Cdiv class=\"control\"\u003E";

pug_html = pug_html + "\n        \u003Clabel\u003E";

pug_html = pug_html + "Expires on\u003C\u002Flabel\u003E";

pug_html = pug_html + "\n        \u003Cp data-bind=\"text: expirationDate\"\u003E";

pug_html = pug_html + "????-??-??\u003C\u002Fp\u003E\n      \u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n      \u003Cdiv class=\"control\"\u003E";

pug_html = pug_html + "\n        \u003Clabel\u003E";

pug_html = pug_html + "Update Channel\u003C\u002Flabel\u003E";

pug_html = pug_html + "\n        \u003Cp data-bind=\"text: updateChannel\"\u003E";

pug_html = pug_html + "?????\u003C\u002Fp\u003E\n      \u003C\u002Fdiv\u003E\n    \u003C\u002Fdiv\u003E\n  \u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n  \u003Ch3\u003E";

pug_html = pug_html + "Update Log\u003C\u002Fh3\u003E";

pug_html = pug_html + "\n  \u003Ctable class=\"table table-hover table-striped\"\u003E";

pug_html = pug_html + "\n    \u003Cthead\u003E";

pug_html = pug_html + "\n      \u003Ctr\u003E";

pug_html = pug_html + "\n        \u003Cth\u003E";

pug_html = pug_html + "Date\u002FTime\u003C\u002Fth\u003E";

pug_html = pug_html + "\n        \u003Cth\u003E";

pug_html = pug_html + "Components\u003C\u002Fth\u003E\n      \u003C\u002Ftr\u003E\n    \u003C\u002Fthead\u003E";

pug_html = pug_html + "\n    \u003Ctbody data-bind=\"foreach: updateLog\"\u003E";

pug_html = pug_html + "\n      \u003Ctr\u003E";

pug_html = pug_html + "\n        \u003Ctd data-bind=\"text: time\"\u003E\u003C\u002Ftd\u003E";

pug_html = pug_html + "\n        \u003Ctd\u003E";

pug_html = pug_html + "\n          \u003Cul class=\"updates\" data-bind=\"foreach: updates\"\u003E";

pug_html = pug_html + "\n            \u003Cli\u003E";

pug_html = pug_html + "\u003Cspan data-bind=\"text: $parents[1].packageNames[package.package] || package.package, title: package.package\"\u003E\u003C\u002Fspan\u003E\u003C\u002Fli\u003E\n          \u003C\u002Ful\u003E\n        \u003C\u002Ftd\u003E\n      \u003C\u002Ftr\u003E\n    \u003C\u002Ftbody\u003E\n  \u003C\u002Ftable\u003E\n\u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n\u003Cdiv class=\"dialog-buttons\"\u003E";

pug_html = pug_html + "\n  \u003Cbutton class=\"save-button\" data-bind=\"click: register, enable: license().key(), visible: !license().valid\"\u003E";

pug_html = pug_html + "Register CaptureCast\u003C\u002Fbutton\u003E\n\u003C\u002Fdiv\u003E";return pug_html;}

},{"fs":1,"pug-runtime":"pug-runtime"}],5:[function(require,module,exports){
var pug = require('pug-runtime');
module.exports=template;function pug_rethrow(n,e,r,t){if(!(n instanceof Error))throw n;if(!("undefined"==typeof window&&e||t))throw n.message+=" on line "+r,n;try{t=t||require("fs").readFileSync(e,"utf8")}catch(e){pug_rethrow(n,null,r)}var i=3,a=t.split("\n"),o=Math.max(r-i,0),h=Math.min(a.length,r+i),i=a.slice(o,h).map(function(n,e){var t=e+o+1;return(t==r?"  > ":"    ")+t+"| "+n}).join("\n");throw n.path=e,n.message=(e||"Pug")+":"+r+"\n"+i+"\n\n"+n.message,n}function template(locals) {var pug_html = "", pug_mixins = {}, pug_interp;
var pug_indent = [];

pug_html = pug_html + "\n\u003Cdiv class=\"modal-dialog update-progress\" data-bind=\"dialog: $root\"\u003E";

pug_html = pug_html + "\n  \u003Ch1\u003E";

pug_html = pug_html + "Installing Updates\u003C\u002Fh1\u003E";

pug_html = pug_html + "\n  \u003Cdiv class=\"alert alert-block alert-error\"\u003E";

pug_html = pug_html + "\n    \u003Ch4\u003E";

pug_html = pug_html + "Do not interrupt the update process or restart CaptureCast or the recorder.\u003C\u002Fh4\u003E";

pug_html = pug_html + "\n    \u003Cp\u003E";

pug_html = pug_html + "CaptureCast will automatically be restarted once the update is complete.\u003C\u002Fp\u003E\n  \u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n  \u003Cdiv class=\"message\" data-bind=\"text: progress().message\"\u003E\u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n  \u003Cdiv class=\"progress-bar\"\u003E";

pug_html = pug_html + "\n    \u003Cdiv class=\"value\" data-bind=\"style: { width: (progress().progress * 100) + '%' }\"\u003E\u003C\u002Fdiv\u003E\n  \u003C\u002Fdiv\u003E\n\u003C\u002Fdiv\u003E";return pug_html;}

},{"fs":1,"pug-runtime":"pug-runtime"}],6:[function(require,module,exports){
const ko = require("knockout");
const Dialog = require("cattura-ui-library/src/lib/ui/dialog");

const template = require("./content.pug");

const dialog = Dialog({
    progress: ko.observable(),
    
    open (progress)
    {
        this.progress(progress);
        
        if (!this.isVisible())
        {
            this.show();
        }
    }
}, { template: template, easilyCloseable: false });

module.exports = dialog;

},{"./content.pug":5,"cattura-ui-library/src/lib/ui/dialog":"cattura-ui-library/src/lib/ui/dialog","knockout":"knockout"}],7:[function(require,module,exports){
var pug = require('pug-runtime');
module.exports=template;function pug_attr(t,e,n,r){if(!1===e||null==e||!e&&("class"===t||"style"===t))return"";if(!0===e)return" "+(r?t:t+'="'+t+'"');var f=typeof e;return"object"!==f&&"function"!==f||"function"!=typeof e.toJSON||(e=e.toJSON()),"string"==typeof e||(e=JSON.stringify(e),n||-1===e.indexOf('"'))?(n&&(e=pug_escape(e))," "+t+'="'+e+'"'):" "+t+"='"+e.replace(/'/g,"&#39;")+"'"}
function pug_escape(e){var a=""+e,t=pug_match_html.exec(a);if(!t)return e;var r,c,n,s="";for(r=t.index,c=0;r<a.length;r++){switch(a.charCodeAt(r)){case 34:n="&quot;";break;case 38:n="&amp;";break;case 60:n="&lt;";break;case 62:n="&gt;";break;default:continue}c!==r&&(s+=a.substring(c,r)),c=r+1,s+=n}return c!==r?s+a.substring(c,r):s}
var pug_match_html=/["&<>]/;
function pug_rethrow(n,e,r,t){if(!(n instanceof Error))throw n;if(!("undefined"==typeof window&&e||t))throw n.message+=" on line "+r,n;try{t=t||require("fs").readFileSync(e,"utf8")}catch(e){pug_rethrow(n,null,r)}var i=3,a=t.split("\n"),o=Math.max(r-i,0),h=Math.min(a.length,r+i),i=a.slice(o,h).map(function(n,e){var t=e+o+1;return(t==r?"  > ":"    ")+t+"| "+n}).join("\n");throw n.path=e,n.message=(e||"Pug")+":"+r+"\n"+i+"\n\n"+n.message,n}function template(locals) {var pug_html = "", pug_mixins = {}, pug_interp;
var pug_indent = [];

pug_mixins["available-updates"] = pug_interp = function(bind=""){
var block = (this && this.block), attributes = (this && this.attributes) || {};

pug_html = pug_html + "\n";
pug_html = pug_html + pug_indent.join("");
pug_html = pug_html + "\u003Cdiv" + (" class=\"updates\""+pug_attr("data-bind", `${bind}`, true, false)) + "\u003E";

pug_html = pug_html + "\n  ";
pug_html = pug_html + pug_indent.join("");
pug_html = pug_html + "\u003Ch3\u003E";

pug_html = pug_html + "\u003Cspan class=\"package\" data-bind=\"text: $parent.packageNames[package.package] || package.package\"\u003E\u003C\u002Fspan\u003E";

pug_html = pug_html + "";

pug_html = pug_html + "\n    ";
pug_html = pug_html + pug_indent.join("");

pug_html = pug_html + "(";

pug_html = pug_html + "\u003Cspan class=\"version\" data-bind=\"text: currentVersion\"\u003E\u003C\u002Fspan\u003E";

pug_html = pug_html + "";

pug_html = pug_html + "\n    ";
pug_html = pug_html + pug_indent.join("");

pug_html = pug_html + "-\u003E";

pug_html = pug_html + "\n    ";
pug_html = pug_html + pug_indent.join("");

pug_html = pug_html + "";

pug_html = pug_html + "\u003Cspan class=\"version\" data-bind=\"text: newVersion\"\u003E\u003C\u002Fspan\u003E";

pug_html = pug_html + ")\n  ";
pug_html = pug_html + pug_indent.join("");
pug_html = pug_html + "\u003C\u002Fh3\u003E";

pug_html = pug_html + "\n  ";
pug_html = pug_html + pug_indent.join("");
pug_html = pug_html + "\u003Cul class=\"changes\" data-bind=\"foreach: _(changes).map('chandes').flatten().value()\"\u003E";

pug_html = pug_html + "\n    ";
pug_html = pug_html + pug_indent.join("");
pug_html = pug_html + "\u003Cli data-bind=\"text: $data\"\u003E\u003C\u002Fli\u003E\n  ";
pug_html = pug_html + pug_indent.join("");
pug_html = pug_html + "\u003C\u002Ful\u003E\n";
pug_html = pug_html + pug_indent.join("");
pug_html = pug_html + "\u003C\u002Fdiv\u003E";
};

pug_html = pug_html + "\n\u003Cdiv class=\"modal-dialog updates\" data-bind=\"dialog: $root\"\u003E";

pug_html = pug_html + "\n  \u003Cdiv class=\"close icon-close\" data-bind=\"click: hide\"\u003E\u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n  \u003Ch1\u003E";

pug_html = pug_html + "CaptureCast Update\u003C\u002Fh1\u003E";

pug_html = pug_html + "\n  \u003Cdiv data-bind=\"visible: !areUpdatesAvailable()\"\u003E";

pug_html = pug_html + "No updates are available.\u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n  \u003Cdiv data-bind=\"visible: areUpdatesAvailable\"\u003E";

pug_html = pug_html + "\n    \u003Cdiv class=\"capturecast\" data-bind=\"visible: updates().capturecast.length &gt; 0\"\u003E";

pug_html = pug_html + "\n      \u003Ch2\u003E";

pug_html = pug_html + "CaptureCast Updates\u003C\u002Fh2\u003E";

pug_html = pug_html + "\n      \u003Cdiv class=\"support-release-notes\"\u003E\n        ";

pug_html = pug_html + "View the";

pug_html = pug_html + "\n        ";

pug_html = pug_html + "";

pug_html = pug_html + "\u003Ca href=\"https:\u002F\u002Fsupport.catturavideo.com\u002Fsupport\u002Fsolutions\u002Farticles\u002F35000111639-capturecast-version-5-release-notes\"\u003E";

pug_html = pug_html + "release notes\u003C\u002Fa\u003E";

pug_html = pug_html + "";

pug_html = pug_html + "\n        ";

pug_html = pug_html + "on";

pug_html = pug_html + "\n        ";

pug_html = pug_html + "";

pug_html = pug_html + "\u003Ca href=\"https:\u002F\u002Fsupport.catturavideo.com\u002F\"\u003E";

pug_html = pug_html + "our support site\u003C\u002Fa\u003E";

pug_html = pug_html + ".\n      \u003C\u002Fdiv\u003E";

pug_indent.push('      ');
pug_mixins["available-updates"]("foreach: updates().capturecast");
pug_indent.pop();
pug_html = pug_html + "\n    \u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n    \u003Cdiv class=\"other\" data-bind=\"visible: otherUpdates().length &gt; 0\"\u003E";

pug_html = pug_html + "\n      \u003Ch2\u003E";

pug_html = pug_html + "Other Updates\u003C\u002Fh2\u003E";

pug_indent.push('      ');
pug_mixins["available-updates"]("foreach: otherUpdates");
pug_indent.pop();
pug_html = pug_html + "\n    \u003C\u002Fdiv\u003E\n  \u003C\u002Fdiv\u003E";

pug_html = pug_html + "\n  \u003Cdiv class=\"buttons\"\u003E";

pug_html = pug_html + "\n    \u003Cbutton class=\"secondary-button\" data-bind=\"click: hide\"\u003E";

pug_html = pug_html + "Close\u003C\u002Fbutton\u003E";

pug_html = pug_html + "\n    \u003Cbutton class=\"primary-button\" data-bind=\"click: submit, visible: areUpdatesAvailable\"\u003E";

pug_html = pug_html + "Install Updates\u003C\u002Fbutton\u003E\n  \u003C\u002Fdiv\u003E\n\u003C\u002Fdiv\u003E";return pug_html;}

},{"fs":1,"pug-runtime":"pug-runtime"}],8:[function(require,module,exports){
const _ = require("lodash");
const ko = require("knockout");
const Dialog = require("cattura-ui-library/src/lib/ui/dialog");

const template = require("./content.pug");
const packageNames = require("../packageNames");

let areUpdatesAvailable = ko.observable(false);
let updates = ko.observable();
const otherUpdates = ko.computed(() => _(updates() || {}).toPairs().filter(function (pair) {
        return pair[0] !== "capturecast";
    }).map(function (pair) {
        return pair[1];
    }).flatten().value()
);

let resolver = null;

const dialog = Dialog({
    areUpdatesAvailable: areUpdatesAvailable,
    updates: updates,
    packageNames: packageNames,
    otherUpdates: otherUpdates,

    open (updates, areUpdatesAvailable)
    {
        this.updates(updates);
        this.areUpdatesAvailable(areUpdatesAvailable);
        this.show();
        return new Promise((resolve, reject) => resolver = resolve);
    },

    submit ()
    {
        if (!areUpdatesAvailable())
        {
            return;
        }

        resolver(updates());
    }
}, { template: template });

module.exports = dialog;

},{"../packageNames":3,"./content.pug":7,"cattura-ui-library/src/lib/ui/dialog":"cattura-ui-library/src/lib/ui/dialog","knockout":"knockout","lodash":"lodash"}]},{},[2])(2)
});
