const ko = require("knockout");
const Dialog = require("cattura-ui-library/src/lib/ui/dialog");

const template = require("./content.pug");

const dialog = Dialog({
    progress: ko.observable(),
    
    open (progress)
    {
        this.progress(progress);
        
        if (!this.isVisible())
        {
            this.show();
        }
    }
}, { template: template, easilyCloseable: false });

module.exports = dialog;
